import FSM
import utils as u
import menus as m
import os
import pygame
#====================================     

State = type("State", (object,), {})
#====================================     
class State(object):
	def __init__(self, FSM):
		self.FSM = FSM
	def Enter(self):
		pass
	def Execute(self):
		pass
	def Exit(self):
		pass

#====================================     

class LoadSound(State):
	def __init__(self,FSM):
		super(LoadSound, self).__init__(FSM)    
		
	def Enter(self):
		o = self.FSM.owner
		o.header_text = "Load Sound"
		o.pub.register("beat", self)
		self.cur_el = 0
		self.menu = []
		self.menu.append("..")
		self.menu += self.get_file_list(o)
		dirs = u.get_folders(o.load_sound_dir)
		files = u.get_files(o.load_sound_dir, '.wav')

		if o.last_load_sound_id != None and o.last_load_sound_id <= len(self.menu):
			self.cur_el = o.last_load_sound_id
		self.last_preview = None

		if o.keyState[16] > 0 or o.keyState[17] > 0:
			pass
		else:
			u.draw_header(o)
			self.draw_main(o)						
			o.update_display(0)
		super(LoadSound, self).Enter()    

	def Execute(self):
		o = self.FSM.owner 
		m.menu1_actions(self, o)
		if o.keyState[16] == 1:
			m.draw_menu1(o)
			o.update_display(0)
		elif o.keyState[16] == 4:
			u.draw_header(o)
			self.draw_footer(o)
			self.draw_main(o)
			o.update_display(0)

		if o.keyState[0] == 1 or o.keyState[0] == 3 or o.keyState[1] == 1 or o.keyState[1] == 3 or o.keyState[2] == 1 or o.keyState[2] == 3 or o.keyState[3] == 1 or o.keyState[3] == 3:
			u.draw_header(o)
			self.draw_footer(o)
			self.draw_main(o)
			o.update_display(0)				

		if o.keyState[16] > 0 or o.keyState[17] > 0:
			pass
		else:
			u.scroll_ud(o, self)
			if o.keyState[2] == 1:
				if self.is_wav():
					if self.last_preview == self.menu[self.cur_el]:
						pass
					else:
						snd = pygame.mixer.Sound(o.load_sound_dir + self.menu[self.cur_el])
						pygame.mixer.Sound.play(snd) 

			if o.keyState[3] == 1:
				if self.menu[self.cur_el] == '..':
					o.last_load_sound_id = None
					if o.load_sound_dir == '/home/pi/zpc_ct/user/sounds/':
						pass
					else:
						o.load_sound_dir = os.path.dirname(os.path.dirname(o.load_sound_dir))
						o.load_sound_dir += '/'
						self.menu = []
						self.menu.append("..")
						self.menu += self.get_file_list(o)
						self.cur_el = 0

				elif os.path.isdir(o.load_sound_dir + self.menu[self.cur_el]):
					o.load_sound_dir = o.load_sound_dir + self.menu[self.cur_el] + '/'
					self.menu = []
					self.menu.append("..")
					self.menu += self.get_file_list(o)
					self.cur_el = 0

				else:
					o.soundSlots[o.eSound].file = o.load_sound_dir + self.menu[self.cur_el]
					o.soundSlots[o.eSound].volume = 16
					o.soundSlots[o.eSound].pitch = 0
					o.soundSlots[o.eSound].create_sound()
					o.soundSlots[o.eSound].set_pitch()
					o.last_load_sound_id = self.cur_el
					self.FSM.ToTransition('toMain')

	def get_file_list(self, o):
		dirs = os.listdir(o.load_sound_dir)
		dirs.sort()
		return dirs

	def draw_main(self, o):
		al = []
		ypos = 30
		if self.cur_el == 0:
			_iter = 0
			while len(al) < 4:
				if _iter < len(self.menu):
					al.append(self.menu[_iter])
				else:
					break
				_iter += 1

		elif self.cur_el == 1:
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
			if (self.cur_el + 1) < len(self.menu):
				al.append(self.menu[self.cur_el + 1])
			if (self.cur_el + 2) < len(self.menu):
				al.append(self.menu[self.cur_el + 2])

		elif self.cur_el == (len(self.menu) - 2):
			al.append(self.menu[self.cur_el - 2])
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
			al.append(self.menu[self.cur_el + 1])

		elif self.cur_el == (len(self.menu) - 1):
			al.append(self.menu[self.cur_el - 3])
			al.append(self.menu[self.cur_el - 2])
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])

		else:
			al.append(self.menu[self.cur_el - 1])
			al.append(self.menu[self.cur_el])
			al.append(self.menu[self.cur_el + 1])
			al.append(self.menu[self.cur_el + 2])
		
		_iter = 0 
		for i in al:

			if i == self.menu[self.cur_el]:
				if os.path.isdir(o.load_sound_dir + i):
					i += "/"
				o.draw.rectangle((0, ypos, o.width, ypos + 20), outline=0, fill=o.light_grey)
				o.center_block(i, o.h2, [0, ypos, o.width,ypos + 20], o.blue)

			else:
				if os.path.isdir(o.load_sound_dir + i):
					i += "/"
				o.draw.rectangle((0, ypos, o.width, ypos + 20), outline=0, fill=o.blue)
				o.center_block(i, o.h2, [0, ypos, o.width,ypos + 20], o.light_grey)

			ypos += 20
			_iter += 1		    

	def draw_footer(self, o):
		_iter = 0
		width = o.width / 4
		xpos = 0
		yposa = 135 - 25
		yposb = 135
		opts = ["Up", "Down", "Play", "Open"]
		while _iter < 4:
			o.draw.rectangle((xpos, yposa, xpos + width, yposb), outline=0, fill=o.blue)
			if o.keyState[_iter] == 1:
				o.draw.rectangle((xpos, yposa, xpos + width, yposb), outline=0, fill=o.light_grey)
				o.center_block(opts[_iter], o.h2, [xpos,yposa,xpos + width,yposb], o.blue)			
			else:
				if _iter == 2:
					if self.is_wav():
						o.center_block(opts[_iter], o.h2, [xpos,yposa,xpos + width,yposb], o.light_grey)
					else:
						o.center_block(opts[_iter], o.h2, [xpos,yposa,xpos + width,yposb], o.dark_grey)	
				else:
					o.center_block(opts[_iter], o.h2, [xpos,yposa,xpos + width,yposb], o.light_grey)	
			xpos += width
			_iter += 1
		
	def is_wav(self):
		if len(self.menu[self.cur_el]) > 3 and (self.menu[self.cur_el][-1] == 'V' or self.menu[self.cur_el][-1] == 'v') and (self.menu[self.cur_el][-2] == 'A' or self.menu[self.cur_el][-2] == 'a') and (self.menu[self.cur_el][-3] == 'W' or self.menu[self.cur_el][-3] == 'w'):
			return True
		else:
			return False

	def ReceiveMessage(self, message):
		o = self.FSM.owner 
		u.play_seq(o, message)
		
	def Exit(self):
		self.FSM.owner.pub.unregister("beat", self)
